//
//  SIDObject.h
//  SocialID
//
//  Created by Renato Neves on 2/4/14.
//  Copyright (c) 2014 Coffee Bean Tech. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef void (^SIDCallbackBlock)(BOOL succeeded, NSError *error);

@interface SIDObject : NSObject

/**
 Saves the object immediately, if the network connection is reachable,
 or enqueue the save operation until the network is available.
 */
- (void) save;

/**
 Saves the object immediately, independently if there is network connection or not.
 */
- (void) saveImmediately;

/**
 Saves the object executing the given callback after it finishes.
 */
- (void) saveWithCallback:(SIDCallbackBlock)callback;

/**
 Enqueues the save operation and executes it when the network status changes
 to reachable.
 */
- (void) saveReachable;

@end
